# Goober, a mobile app for pnut.io

Copyright 2017 - 2020 Morgan McMillian

Goober is a cross platform mobile client for pnut.io built using the Ionic framework (http://ionicframework.com/).


## LICENSE

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

&nbsp;

_**Specific details about my build environment can be found on the following Wiki page.**_
https://gitlab.dreamfall.space/thrrgilag/Goober/wikis/build-notes

&nbsp;

## Core build dependencies

Goober was developed using v3 of the Ionic framework.  Since Goober's initial development Ionic has made major breaking changes starting with v4 and as a result this app no longer builds with the latest version of those tools.

* Install Node.js (https://nodejs.org)
* Install Ionic v3 and Cordova

```bash
npm install -g ionic@3 cordova
```


## Platform build dependencies

#### Android
* Install Java Development Kit
* https://java.com
* Install either Android Studio or the command line tools
* https://developer.android.com/studio/index.html#downloads
* Install Gradle (needed if you only installed the command line tools)
* https://gradle.org/


## Other build dependencies

Install required node modules
```bash
cd Goober
npm install
```


Install at least one target platform
```bash
ionic cordova platform add android
```


## Build and run using ionic framework

Copy src/providers/pnut-oauth.ts.sample to src/providers/pnut-oauth.ts and include the client ID provided by pnut.io. See the [developer documentation](https://pnut.io/docs/api/implementation/overview) for more details.

#### Browser
```bash
ionic serve --lab
```

#### Android
```bash
ionic cordova platform add android
ionic cordova build android
ionic cordova run android
```

